#!/bin/sh

# -----------------------------------------

if ! [ "$1" ] || ! [ "$2" ]; then
  echo "Usage: $0 {user} {domain} {root-dir}"
  exit 1 ;
fi

# -----------------------------------------

USERHOST="$1"
SERVER_NAME="$2"
ROOT_DIR="$3"

TEST_HTML="$ROOT_DIR/index.html"

HOST_CONFIG_FILE="/etc/nginx/sites-available/$2"
HOST_SYMBOLIC_DIR="/etc/nginx/sites-enabled/"
HOST_SYMBOLIC_FILE="/etc/nginx/sites-enabled/$2"

# -----------------------------------------

# START function create_root_folder
function create_root_folder {
  # creating root folder
  mkdir -p $ROOT_DIR

  # setting ownership and permission
  echo "Setting root folder's ownership and permission ..."
  chown -R $USERHOST:www-data $ROOT_DIR
  sudo chmod -R 755 $ROOT_DIR

  # creating test index.html
  echo "Creating the test index.html ..."
  touch $TEST_HTML
  cat > $TEST_HTML << EOL
  <html>
      <head>
          <title>Welcome to ${SERVER_NAME}!</title>
      </head>
      <body>
          <h1>Success!  The ${SERVER_NAME} server block is working!</h1>
      </body>
  </html>
EOL
}
# END function create_root_folder

# -----------------------------------------

# START function create_host_configuration_file
function create_host_configuration_file {

touch $HOST_CONFIG_FILE
cat > $HOST_CONFIG_FILE << EOL
##
# Server configuration
##
server {
  listen 80;
  listen [::]:80;

  # SSL configuration
  #
  # listen 443 ssl default_server;
  # listen [::]:443 ssl default_server;
  #
  # Note: You should disable gzip for SSL traffic.
  # See: https://bugs.debian.org/773332
  #
  # Read up on ssl_ciphers to ensure a secure configuration.
  # See: https://bugs.debian.org/765782
  #
  # Self signed certs generated by the ssl-cert package
  # Don't use them in a production server!
  #
  # include snippets/snakeoil.conf;

  root $ROOT_DIR;

  # Add index.php to the list if you are using PHP
  index index.html index.htm index.php index.nginx-debian.html;

  server_name ${SERVER_NAME} *.${SERVER_NAME};

  location / {
    # First attempt to serve request as file, then
    # as directory, then fall back to displaying a 404.
    try_files $uri $uri/ /index.php?$args;
  }

  # pass the PHP scripts to FastCGI server listening on 127.0.0.1:9000
  #
  location ~ \.php\$ {
    include snippets/fastcgi-php.conf;

    # With php7.0-cgi alone:
    # fastcgi_pass 127.0.0.1:9000;
    # With php7.0-fpm:
    fastcgi_pass unix:/run/php/php7.0-fpm.sock;
  }
}
EOL

  echo "Creating host config symbolic links ..."
  if ! [ -d "$HOST_SYMBOLIC_DIR" ]; then
    mkdir $HOST_SYMBOLIC_DIR
  fi

  if ! [ -f "$HOST_SYMBOLIC_FILE" ]; then
    ln -s $HOST_CONFIG_FILE $HOST_SYMBOLIC_DIR
  fi
}
# END function create_host_configuration_file

# -----------------------------------------

function root_folder_exist_confirm {
  read -p "The root folder is existed : re-create(1) / skip(2) / exit(3) ? " choice
  case "$choice" in
    1 ) echo "Re-create root folder ..."; create_root_folder;;
    2 ) ;;
    3 ) exit 1;;
    * ) root_folder_exist_confirm;;
  esac
}

# -----------------------------------------

function config_file_exist_confirm {
  read -p "Host configuration file is existed : re-create(1) / skip(2) / exit(3) ? " choice
  case "$choice" in
    1 ) echo "Re-create host configuration file ..."; create_host_configuration_file;;
    2 ) ;;
    3 ) exit 1;;
    * ) config_file_exist_confirm;;
  esac
}

# -----------------------------------------

echo "";
echo "Checking root folder ..."
if [ -d "$ROOT_DIR" ]; then
  root_folder_exist_confirm
else
  echo "Creating root folder ..."
  create_root_folder
fi

# -----------------------------------------

echo "Checking host config file ..."
if [ -f "$HOST_CONFIG_FILE" ]; then
  config_file_exist_confirm
else
  echo "Creating host configuration file ..."
  create_host_configuration_file
fi

# -----------------------------------------

# setting ownership and permission
echo "Reset root folder's ownership and permission ..."
chown -R $USERHOST:www-data $ROOT_DIR
sudo chmod -R 755 $ROOT_DIR

# -----------------------------------------

echo "Nginx checking configuration..."
if nginx -t && echo "Restarting Nginx server ..." && systemctl restart nginx; then
  echo ""
  echo "Finish creating host $SERVER_NAME with root folder in $ROOT_DIR"
else
  echo ""
  echo "Fail to create host for $SERVER_NAME. Configuration error."
fi
echo ""
